
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org GSM Call Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.GSM.Call</h1><h2>Description</h2>
<p>The Call interface is used to initiate, accept, release, and otherwise deal  with voice calls. It also allows you to send DTMF tones.</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.GSM.Call</tt></p>
<h2>Methods</h2><ul>
<li><a href="#Emergency">Emergency</a></li>
<li><a href="#Activate">Activate</a></li>
<li><a href="#ActivateConference">ActivateConference</a></li>
<li><a href="#Release">Release</a></li>
<li><a href="#HoldActive">HoldActive</a></li>
<li><a href="#Join">Join</a></li>
<li><a href="#Transfer">Transfer</a></li>
<li><a href="#Deflect">Deflect</a></li>
<li><a href="#ReleaseHeld">ReleaseHeld</a></li>
<li><a href="#ReleaseAll">ReleaseAll</a></li>
<li><a href="#Initiate">Initiate</a></li>
<li><a href="#ListCalls">ListCalls</a></li>
<li><a href="#SendDtmf">SendDtmf</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#CallStatus">CallStatus</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><i>None</i>
<h1>Methods</h1><h3><a name="Emergency">Emergency</a> ( s )</h3>
<p><i>Description:</i> Initiate an emergency call. </p><p><div class="rationale"><p>This maps to ATD(number);, see v.250. </p></div></p><h4>Parameters</h4><i>s: number</i><p>The emergency number to dial. National and world-wide restrictions apply. </p>
<h3><a name="Activate">Activate</a> ( i )</h3>
<p><i>Description:</i> Activate a call as single active call. All previously active calls are  put on hold. No difference is made whether this is an incoming  call or a call that has been put on hold. </p><p><div class="rationale"><p>This can map to ATA, see v.250. It might also map to GSM 07.07 +CHLD=..., see 3GPP TS 07.07 Chapter 7.12. </p></div></p><h4>Parameters</h4><i>i: id</i><p> </p>
<h3><a name="ActivateConference">ActivateConference</a> ( i )</h3>
<p><i>Description:</i> Activate a call in addition to all previously active calls.  No difference is made whether this is an incoming  call or a call that has been put on hold. </p><p><div class="rationale"><p>This maps to GSM 07.07 +CHLD=..., see 3GPP TS 07.07 Chapter 7.12. </p></div></p><h4>Parameters</h4><i>i: id</i><p> </p>
<h3><a name="Release">Release</a> ( i )</h3>
<p><i>Description:</i> Release a call. </p><p><div class="rationale"><p>This can map to ATH, see v.250. It might also map to GSM 07.07 +CHLD=..., see 3GPP TS 07.07 Chapter 7.12. Some implementations might map it to GSM 07.07 +CHUP=, see 3GPP TS 07.07 Chapter 6.5. </p></div></p><h4>Parameters</h4><i>i: id</i><p> </p>
<h3><a name="HoldActive">HoldActive</a> ( )</h3><p><i>Description:</i> Hold the active call. </p><p><div class="rationale"><p>This maps to GSM 07.07 +CHLD=2, see 3GPP TS 07.07 Chapter 7.12. </p></div></p>
<h3><a name="Join">Join</a> ( )</h3><p><i>Description:</i> Join all active and held calls and release yourself from the conversation. </p><p><div class="rationale"><p>This maps to GSM 07.07 +CHLD=4, see 3GPP TS 07.07 Chapter 7.12. </p></div></p>
<h3><a name="Transfer">Transfer</a> ( )</h3><p><i>Description:</i> Join the currently active and held calls together and disconnect both calls. </p><p><div class="rationale"><p>This usually maps to the +CHLD AT command, see 3GPP TS 27.07 Chapter 7.13. </p></div></p>
<h3><a name="Deflect">Deflect</a> ( s )</h3>
<p><i>Description:</i> Deflect an incoming or active call to another number. </p><p><div class="rationale"><p>This maps to GSM 07.07 +CTFR=..., see 3GPP TS 27.07 Chapter 7.14. </p></div></p><h4>Parameters</h4><i>s: number</i><p>The number to transfer the call to. </p>
<h3><a name="ReleaseHeld">ReleaseHeld</a> ( )</h3><p><i>Description:</i> Release all held calls. </p><p><div class="rationale"><p>This maps to GSM 07.07 +CHLD=, see 3GPP TS 07.07 Chapter 7.12. </p></div></p>
<h3><a name="ReleaseAll">ReleaseAll</a> ( )</h3><p><i>Description:</i> Release all calls, no matter whether active or put on hold. </p><p><div class="rationale"><p>This maps to ATH, see v.250. </p></div></p>
<h3><a name="Initiate">Initiate</a> ( ss ) &rarr; i</h3>
<p><i>Description:</i> Initiate an outgoing call. </p><p><div class="rationale"><p>This maps to ATD(number);, see v.250. </p></div></p><h4>Parameters</h4><i>s: number</i><p>The number to call. </p><i>s: type</i><p>The type of call to made. Valid values are:  <ul>  <li>"voice" - a GSM voice call,</li>  <li>"data" - a GSM data call,</li>  <li>"fax" - a FAX call.</li>  </ul> </p><h4>Returns</h4><i>i: id</i><p>The reference id for this call. It will get assigned by the system. </p>
<h3><a name="ListCalls">ListCalls</a> ( ) &rarr; a(isa{sv})</h3>
<p><i>Description:</i> Retrieve the status for all calls in the system. </p><h4>Returns</h4><i>a(isa{sv}): call_details</i><p>The call status. This is an array containing a call status record for every single call.  See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.Call.html#CallStatus">CallStatus</a> signal for a description of the format. </p>
<h3><a name="SendDtmf">SendDtmf</a> ( s )</h3>
<p><i>Description:</i> Send one or more Dual Tone Multiple Frequency (DTMF) signals during an active call. </p><p><div class="rationale"><p>This maps to the TIA IS 101 command +VTS=(value), see 3GPP TS 07.07 Chapter C.2.11.  Note: DTMF signals are always sent to all active calls, this is a limitation of the underlying protocols. </p></div></p><h4>Parameters</h4><i>s: tones</i><p>The tones to send. Allowed values are: (0-9,#,*,A-D) </p>
<h1>Signals</h1><h3><h3><a name="CallStatus">CallStatus</a> ( isa{sv} )</h3><p><i>Description:</i> Sent whenever there is any status or property change on a call in the system,  no matter whether this is an incoming, active, held, or released call. </p><h4>Parameters</h4><i>i: id</i><p>The index of the call that changed its status or properties. </p><i>s: status</i><p>The new status of the call. Expected values are:  <ul>  <li>"incoming" = The call is incoming (but not yet accepted),</li>  <li>"outgoing" = The call is outgoing (but not yet established),</li>  <li>"active" = The call is the active call (you can talk),</li>  <li>"held" = The call is being held,</li>  <li>"release" = The call has been released.</li>  </ul>  Further information can be part of the properties. </p><i>a{sv}: properties</i><p>An array of property values. Note that some properties are optional. Mandatory tuples are:  <ul>  <li>( "direction", string ) = "incoming" or "outgoing",</li>  <li>( "peer", string ) = The number of the peer (on incoming calls only if we received a CLIP).</li>  </ul>  Optional tuples include:  <ul>  <li>( "reason", string ) = The reason for the status change (on outgoing calls e.g. 'BUSY' or 'NO CARRIER'),</li>  <li>( "auxstatus", string ) = An auxillary connection status (if your modem supports that),</li>  <li>( "line", string ) = The GSM line (0 or 1) this call is taking place (on modems that support multiple lines).</li>  <ul> </p></h3>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

